extends ../_docs-template

block vars
  - var title = 'Preloader | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content
    .motion-docs-page-title
      h1 Preloader
      script(src="/js/motion/preloader.js")
      f7-motion-preloader(motion)

    p Framework7 has a nice preloader indicator. Preloader is made with SVG and animated with CSS so it can be easily resized.
    h2 Preloader Layout
    p Layout is pretty simple:
    :code(lang="html")
      <div class="preloader"></div>
    p This layout will work if you put preloader on a page before its initialization. If you need to add it page later or to use in custom layouts then use full preloader layout. It is different for each theme:
    h4 iOS Theme Preloader Layout
    :code(lang="html")
      <div class="preloader">
        <span class="preloader-inner">
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
          <span class="preloader-inner-line"></span>
        </span>
      </div>
    h4 MD Theme Preloader Layout
    :code(lang="html")
      <div class="preloader">
        <span class="preloader-inner">
          <svg viewBox="0 0 36 36">
            <circle cx="18" cy="18" r="16"></circle>
          </svg>
        </span>
      </div>

    h2 Preloader Colors
    p Preloader supports all <a href="color-themes.html">default colors</a>. So to change its color just add `color-[color]` class to preloader element.
    p MD theme also supports special `color-multi` color to make preloader multi-color.
    pre.html
      code
        :code(lang="html")
          <!-- Red preloader -->
          <div class="preloader color-red"></div>

          <!-- Green preloader -->
          <div class="preloader color-green"></div>

          <!-- Multicolor preloader -->
          <div class="preloader color-multi"></div>
    h2 Preloader Overlay / Preloader API
    p It is also possible to call special Preloader overlay which is useful if you need to block user actions until something is loaded. This kind of preloader will appear in front of app and block any user actions behind it.
    p Let's look at related app methods to work with Preloader overlay
    .method-wrap
      p
        span.method app.preloader.show(<span>color</span>)
        | - show Preloader overlay
      ul.method-parameters
        li
          span.parameter color
          |  - <span class="parameter-type">string</span>. Preloader color, one of the <a href="color-themes.html">default colors</a>
    .method-wrap
      p
        span.method app.preloader.hide()
        | - hide Preloader overlay
    .method-wrap
      p
        span.method app.preloader.showIn(<span>el</span>, <span>color</span>)
        | - show Preloader overlay in specified element
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Element where preloader overlay will be added
        li
          span.parameter color
          |  - <span class="parameter-type">string</span>. Preloader color, one of the <a href="color-themes.html">default colors</a>
    .method-wrap
      p
        span.method app.preloader.hideIn(<span>el</span>)
        | - hide Preloader overlay in specified element
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Element where preloader overlay should be removed from

    p For example:
    :code(lang="js")
          var app = new Framework7();

          // Show preloader before Ajax request
          app.preloader.show();

          // Perform Ajax request
          fetch('someurl.html').then(() => {
            // Hide preloader when Ajax request completed
            app.preloader.hide();
          });
    .important-note
      p Opening Preloader overlay will also add `with-modal-preloader` class to <html> element.

    +cssVars('preloader')


    h2 Examples
    +examplePreview('core', 'preloader.html', 'preloader')
